clear all
close all
clc
format long

L = 1;
nH = 7;
n = 2*nH+1;
mode = 4;
[ Ah,Ahh,h ] = oneDLaplacianMatrix( n, L );



H = 2 *h;

[I_h_H,n2] = oneDRestriction(n);
[I_H_h,n2] = oneDProlongation(n);
AH = I_h_H * Ah * I_H_h;



[Vh,D] = eig(Ah);
d = diag(D);
[VH,DH] = eig(AH);


V = zeros(n,n);
for k =1:n
    for i =1:n
        V(i,k) = sin(i*k*pi/(n+1));
    end
end


[Vh,Dh] = eig(Ah);

tmp = diag(V'*Vh);
for i=1:n
   if tmp(i) < 0
       Vh(:,i) = -Vh(:,i);
   end
end
tmp = diag(VH'*I_h_H*Vh);
for i=1:((n-1)/2)
   VH(:,i) = VH(:,i)/tmp(i); % change the norm 
end

xH = VH(:,mode);
maxx = max(abs(xH));
xH = xH / maxx;

xh = I_H_h * xH;

figure
subplot(2,3,1)
plot([0:H:L],[0;xH;0],'o-','linewidth',2)

box on 
grid on
subplot(2,3,2)
plot([0:h:L],[0;xh;0],'o-','linewidth',2)
box on 
grid on
subplot(2,3,3)
plot([0:h:L],[0;xh;0],'o-','linewidth',2)
hold on
plot([0:H:L],[0;xH;0],'o-','linewidth',2)
plot([0:H:L],[0;VH(:,mode);0]*norm([0;xH;0])/norm([0;VH(:,mode);0]),'o--','linewidth',2)
box on 
grid on
subplot(2,3,4)

plot(0:((n-1)/2-1),VH'*xH,'o-','linewidth',2)
box on 
grid on
subplot(2,3,5)
plot(0:(n-1),Vh'*xh,'o-','linewidth',2)
box on 
grid on
subplot(2,3,6)
plot(0:(n-1),Vh'*xh,'o-','linewidth',2)
hold on
plot(0:((n-1)/2-1),VH'*xH,'o-','linewidth',2)
plot(0:((n-1)/2-1),VH'*VH(:,mode)*norm([0;xH;0])/norm([0;VH(:,mode);0]),'o--','linewidth',2)

box on 
grid on

figure
tmp = Vh'*xh;
subplot(2,2,1)
plot(0:(nH-1),VH'*xH,'o-','linewidth',2)
subplot(2,2,2)
plot(0:(nH-1),tmp(1:nH),'o-','linewidth',2)
subplot(2,2,4)
plot(0:(nH-1),tmp(n:-1:n-nH+1),'o-','linewidth',2)
